///////////////////////////////////////////////////////////////////////////////
//
//
//
//
///////////////////////////////////////////////////////////////////////////////

#include "Common.ch"
#include "getexit.ch"
#include "inkey.ch"
#include "set.ch"
#include "setcurs.ch"
#include "std.ch"
#include "Appevent.ch"
#include "Xbp.ch"
#include "gra.ch"
#include "dcgra.ch"
#include "Dmlb.ch"
#include "get.ch"
#include "fileio.ch"
#include "dcdialog.ch"


#PRAGMA LIBRARY( "ASCOM10.LIB" )

PROCEDURE Main
local getlist:={}
local m_title:='Test Program'
local process:=.f.


        @ 5, 10  dcsay 'customer screen mock up'

        @ 9,15 DCPUSHBUTTON CAPTION 'CC info' ;
                          SIZE 10,1 ;
                        ACTION {||cust_card()}

  if EditGui1(@GetList,@Process,9,.t.,m_title)
    //  msgbox('quit')
  endif
/*

*/
*********************************************
procedure cust_card()
    local getlist:={}
    local m_TITLE:="Credit Card Information"
    local a_type:={'VISA','MC','AMEX','DISC'}
    local tmpcard:=space(20)
    local line:=8, cip_call:=.f.

    private fname:=space(10), lname:=space(15),cmpny:=space(25)
    private cip_id:='0', cip_pay:='0', cip_type:='',cip_card:=''

              fname := 'Milton'
              lname := 'Friedman'
              cmpny := 'Monetarists, Inc.'


              @ 1,  2 dcsay "First Name" saysize 12    //grastring
              @ 2,  2 dcsay "Last Name"  saysize 12 //grastring
              @ 3,  2 dcsay "Company "   saysize 10//grastring
              @ 4.2, 19 dcsay "Customer Reference Number"
              @ 4.2, 46 dcsay cip_id saycolor 10 saysize 0

              @ 1, 19 dcget fname  pict '@!' GETSIZE 16 TABSTOP getid 'Name'//cust[31] pict '99/99' TABSTOP
              @ 2, 19 dcget lname  pict '@!' GETSIZE 26 TABSTOP // tmpcard pict '9999999999999999'TABSTOP  //card_dec(cust[30])
              @ 3, 19 dcget cmpny  pict '@!' GETSIZE 26 TABSTOP  //cust[75] pict '@!S20' TABSTOP
              line := 6

               @ 6, 20 DCPUSHBUTTON CAPTION '~CC Sale' SIZE 15,1.2;
              ACTION {||CIPCreditSale() };
              TABSTOP;
              ACCELKEY xbeK_ALT_C


              @ 6, 40 DCPUSHBUTTON CAPTION '~Post to CIP' SIZE 15,1.2;
              ACTION {||IIF(empty(fname)  .and. empty(lname), (msgbox('Cannot post blank data'), SetAppFocus(DC_GetObject(Getlist,'Name')) ), (DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList,process:=.t.), cip_call:=.t. ))};
              TABSTOP;
              ACCELKEY xbeK_ALT_P

        if EditGui1(@GetList,@Process,line,.t.,m_title)
             if cip_call
               //Call_CIPNET(@cip_id,@cip_pay,@cip_type,@cip_card)
               CIPUpdatePayments()
             endif
        endif

return

******************************************
function CIPUpdatePayments()
Local oEasyIntegrator, ret_val:=.f.
local SetupString:='',nVar:=1
local trans
local oCustfields
local oCustomer
local StringSavedCustomerRef:=''

SetupString:=GetCIPsetup(nVar)
if !(ValType(oEasyIntegrator)) == 'O'
   oEasyIntegrator:=ActiveXObject():Create("cipwin32.EasyIntegrator")
endif

IF NIL == oEasyIntegrator                                                   // test to see if it got created
    msgbox( "Error: " + Chr(13) + Chr(10) + "Description: " + ComLastMessage() )
    //MsgBox( "Description:" + ComLastMessage() )                             // show error message if not
    RETURN .f.
ElSE
    ret_val := .t.
ENDIF

   oEasyIntegrator:LoadSetup(SetupString)
   trans := oEasyIntegrator:getProperty('TransFields')
   trans:AmountTotal := 4
   oCustomer := oEasyIntegrator:getProperty('Customer')
   oCustfields := oCustomer:getProperty('CustomerFields')
   oEasyIntegrator:Customer:CustomerFields:Clear()
   oCustfields:FirstName := 'Enrico'
   oCustfields:LastName := 'Fermi'
   oCustfields:Company := 'E=mc2'
   oCustomer:UpdatePayments('50243')     //43234     //50243
   StringSavedCustomerRef = oEasyIntegrator:Customer:CustomerRef
   msgbox(StringSavedCustomerRef)
return ret_val

******************************************
function CIPCreditSale()
Local oEasyIntegrator, ret_val:=.f.
local SetupString:='',nVar:=1
local trans
local oCustfields
local oCustomer

SetupString:=GetCIPsetup(nVar)
if !(ValType(oEasyIntegrator)) == 'O'
   oEasyIntegrator:=ActiveXObject():Create("cipwin32.EasyIntegrator")
endif

IF NIL == oEasyIntegrator                                                   // test to see if it got created
    msgbox( "Error: " + Chr(13) + Chr(10) + "Description: " + ComLastMessage() )
    RETURN .f.
ElSE
    ret_val := .t.
ENDIF

   oEasyIntegrator:LoadSetup(SetupString)
   trans := oEasyIntegrator:getProperty('TransFields')
   trans:AmountTotal := 4
   oCustomer := oEasyIntegrator:getProperty('Customer')
   oCustomer:CustomerRef := '50243'
   oEasyIntegrator:CreditSale()

return ret_val


*/
*********************************************
/*
procedure CIPwrite(CIPString)
local nHandle,mpath

    mpath  := 'CIPsetup.xml'
    nHandle:= FCreate(mpath,FC_NORMAL)
    IF nHandle == -1
         msgbox('Error creating CIP setup file: ' + str(FError()) )
    ELSE
         FWrite( nHandle, CIPString)
         FClose( nHandle )
         msgbox('Setup string saved to CIPsetup.xml file')
    ENDIF

return
*/
**********************************************
function GetCIPsetup(nVar)
    #include "fileio.ch"
    local n:=0
    local nHandle, m_File, CIPsetup:=space(4000), nBytes:=0

    // nVar = 1  calling setup screen
    // nVar = 2  loading setup

    if nVar = 2
         msgbox('Loading setup from CIPsetup.xml file')
    endif

    m_File:='CIPsetup.xml'
    if file(m_File)
        nHandle:=FOPEN(m_File,FO_READ)
        if ferror() !=0
            msgbox('File Open Error ')
        else
       nBytes:=fread(nHandle,@CIPsetup,4000)
            fclose(nHandle)
        endif
        CIPsetup:=trim(CIPsetup)
        if nVar = 2
            msgbox('setup loaded')
        endif

    endif

return CIPsetup
******************************************
function EditGui1(GetList,Process,nVar,lVar,m_Title)
    local getoptions

 //   DCHOTKEY xbeK_F1 ACTION {||call_help()}

    AddEditButtons1(@GetList,@Process,nVar,lVar)

    DCGETOPTIONS NORESIZE NOMINBUTTON NOMAXBUTTON;
    CLOSEQUERY MSG{||.f.}  ;
    sayfont '10.arial';
    COLORGETS {{ GRA_CLR_BLUE, GRA_CLR_WHITE}}



    DCREAD GUI MODAL FIT;
    TITLE m_title;
    setappwindow;
    OPTIONS GETOPTIONS

return process
***********************************************
procedure AddEditButtons1(GetList,Process,rRow,lEdit)
//CONSTRUCT THE PUSHBUTTON OPTIONS FOR EDIT DATA FILES
    if lEdit
        @ rRow, 1 DCPUSHBUTTON CAPTION '~Close' SIZE 9,1.2;
        ID 'OKBUTT';
        ACTION {||DC_ReadGuiEvent(DCGUI_EXIT_OK,GetList,process:=.t.)};
        TABSTOP;
        ACCELKEY xbeK_ALT_O
    endif
return

***********************************************
procedure ExitProgram()
   QUIT
return